package me.Spiritwo.silktouch;

import java.util.ArrayList;
import java.util.logging.Logger;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

public class SilkTouch extends JavaPlugin
{

	public Logger log = Logger.getLogger("Minecraft");
	
	public ArrayList<String> activePlayers = new ArrayList<String>();
	public ArrayList<String> activeSuperPlayers = new ArrayList<String>();
	
	public void onEnable()
	{
		PluginManager manager = this.getServer().getPluginManager();
		manager.registerEvents(new SilkTouchListeners(this), this);
		
		getConfig().options().copyDefaults(true);
		saveConfig();
		
	}
	
	public void onDisable()
	{

	}

	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args)
	{
		if(sender instanceof Player)
		{
			Player player = (Player) sender;
			String playerName = player.getName();
			String playerSuperName = player.getName();
			
			if (cmd.getName().equalsIgnoreCase("silk"))
			{
				if (args.length == 1 && args[0].equalsIgnoreCase("on"))
				{
					if (player.hasPermission("machisilk.silktoggle") || player.isOp())
					{
						if (this.activeSuperPlayers.contains(playerSuperName))
						{
							player.sendMessage(ChatColor.RED + "Please disable super silk touch mode first.");
							return true;
						}
						if (this.activePlayers.contains(playerName))
						{
							player.sendMessage(ChatColor.RED + "Silk Touch mode is already activated.");
							return true;
						}
						
						this.activePlayers.add(playerName);
						player.sendMessage(ChatColor.GREEN + "Silk Touch mode enabled. " + ChatColor.DARK_AQUA + "\nType " + ChatColor.YELLOW + "/silk off" + ChatColor.DARK_AQUA + " to disable silk touch mode.");
						return true;
					}
					else
					{
			            player.sendMessage(ChatColor.RED + "You do not have permission for this command.");
			            return true;
			        }
				}
				else if (args.length == 1 && args[0].equalsIgnoreCase("off"))
				{
					if (player.hasPermission("machisilk.silktoggle") || player.isOp())
					{
						if (!this.activePlayers.contains(playerName))
						{
							player.sendMessage(ChatColor.RED + "Silk Touch mode isn't activated.");
							return true;
						}
						
						this.activePlayers.remove(playerName);
						player.sendMessage(ChatColor.GREEN + "Silk Touch mode disabled.");
						return true;
					}
					else
					{
						player.sendMessage(ChatColor.RED + "You do not have permission for this command.");
						return true;
					}
				}
			}

				
	//Start super pick mode
			if (cmd.getName().equalsIgnoreCase("supersilk"))
			{
				if (args.length == 1 && args[0].equalsIgnoreCase("on"))
				{
					if (player.hasPermission("machisilk.supersilktoggle") || player.isOp())
					{
						if (this.activePlayers.contains(playerName))
						{
							player.sendMessage(ChatColor.RED + "Please disable regular silk touch mode first.");
							return true;
						}
						if (this.activeSuperPlayers.contains(playerSuperName))
						{
							player.sendMessage(ChatColor.RED + "Super Silk Touch mode is already activated.");
							return true;
						}
						
						this.activeSuperPlayers.add(playerSuperName);
						player.sendMessage(ChatColor.GREEN + "Super Silk Touch mode enabled. " + ChatColor.DARK_AQUA + "\nType " + ChatColor.YELLOW + "/supersilk off" + ChatColor.DARK_AQUA + " to disable super silk touch mode.");
						return true;
					}
					else
					{
						player.sendMessage(ChatColor.RED + "You do not have permission for this command.");
						return true;
					}
				}
				else if (args.length == 1 && args[0].equalsIgnoreCase("off"))
				{
					if (player.hasPermission("machisilk.supersilktoggle") || player.isOp())
					{
						if (!this.activeSuperPlayers.contains(playerSuperName))
						{
							player.sendMessage(ChatColor.RED + "Super Silk Touch mode isn't activated.");
							return true;
						}
						
						this.activeSuperPlayers.remove(playerSuperName);
						player.sendMessage(ChatColor.GREEN + "Super Silk Touch mode disabled.");
						return true;
					}
					else
					{
						player.sendMessage(ChatColor.RED + "You do not have permission for this command.");
						return true;
					}
				}
				
			}
			//Start silkstatus
			if (cmd.getName().equalsIgnoreCase("silkstatus"))
			{
				if (args.length == 0)
				{
					if (player.hasPermission("machisilk.silkstatus") || player.isOp())
					{
						if (this.activePlayers.contains(playerName))
						{
							player.sendMessage(ChatColor.DARK_GREEN + "=== " + ChatColor.AQUA + "Silk Status" + ChatColor.DARK_GREEN + " ===");
							player.sendMessage(ChatColor.DARK_AQUA + "Regular silk:" + ChatColor.GREEN + " Enabled");
							player.sendMessage(ChatColor.DARK_AQUA + "Super silk:" + ChatColor.RED + " Disabled");
							return true;
						}
						else if (this.activeSuperPlayers.contains(playerSuperName))
						{
							player.sendMessage(ChatColor.DARK_GREEN + "=== " + ChatColor.AQUA + "Silk Status" + ChatColor.DARK_GREEN + " ===");
							player.sendMessage(ChatColor.DARK_AQUA + "Regular silk:" + ChatColor.RED + " Disabled");
							player.sendMessage(ChatColor.DARK_AQUA + "Super silk:" + ChatColor.GREEN + " Enabled");
							return true;
						}
						else if (!this.activeSuperPlayers.contains(playerSuperName) || !this.activePlayers.contains(playerName))
						{
							player.sendMessage(ChatColor.DARK_GREEN + "=== " + ChatColor.AQUA + "Silk Status" + ChatColor.DARK_GREEN + " ===");
							player.sendMessage(ChatColor.DARK_AQUA + "Regular silk:" + ChatColor.RED + " Disabled");
							player.sendMessage(ChatColor.DARK_AQUA + "Super silk:" + ChatColor.RED + " Disabled");
							return true;
						}
					}
					else
					{
						player.sendMessage(ChatColor.RED + "You do not have permission for this command.");
						return true;
					}
				}
			}
		}
		else
		{
			log.info("This command is only executable in-game");
			return true;
		}
			
	return false;
  }
}