package me.Spiritwo.silktouch;

import org.bukkit.ChatColor;
import org.bukkit.Material;

import org.bukkit.block.Block;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;

public class SilkTouchListeners implements Listener
{
	
	private SilkTouch plugin;
	
	
	public SilkTouchListeners(SilkTouch instance)
	{
		this.plugin = instance;
	}

	@EventHandler(priority = EventPriority.NORMAL)
	public void onPlayerInteract(BlockBreakEvent event)
	{
		    Player player = event.getPlayer();
			Block block = event.getBlock();
			Material type = block.getType();
			
			if(plugin.activePlayers.contains(player.getName()) && type != Material.AIR)
			{
			block.setType(Material.AIR);
			block.getWorld().dropItemNaturally(block.getLocation(), new ItemStack(type, 1));
			}
	}
	
	@EventHandler(priority = EventPriority.NORMAL)
	public void onPlayerInteract(PlayerInteractEvent event)
	{
		Player player = event.getPlayer();
		
		
		if (event.getAction().equals(Action.LEFT_CLICK_BLOCK) && plugin.activeSuperPlayers.contains(player.getName()))
		{
			Block block = event.getClickedBlock();
			Material type = block.getType();
			ItemStack tool = player.getItemInHand();
			FileConfiguration config = this.plugin.getConfig();
			
			if(plugin.activeSuperPlayers.contains(player.getName())  && tool.getTypeId() == config.getInt("superTouchItemID"))
			{
				block.setType(Material.AIR);
				block.getWorld().dropItemNaturally(block.getLocation(), new ItemStack(type, 1));
			}
			else 
			{
				
				event.setCancelled(true);
				player.sendMessage("You must be using a " + ChatColor.GOLD + config.getString("superTouchItemName") + ChatColor.WHITE + " while using super silk touch mode.");
			}
		}
	}
}
